tbb::flow::interface11::overwrite_node< T > Class Template Reference

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::overwrite_node< T >:
Collaboration diagram for tbb::flow::interface11::overwrite_node< T >:

## Classes

struct | register_predecessor_task
| Breaks an infinite loop between the node reservation and register_successor call. More...

## Public Types

typedef T | input_type
typedef T | output_type
typedef receiver< input_type >::predecessor_type | predecessor_type
typedef sender< output_type >::successor_type | successor_type
Public Types inherited from tbb::flow::interface11::internal::untyped_receiver
typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

__TBB_NOINLINE_SYM | overwrite_node (graph &g)
__TBB_NOINLINE_SYM | overwrite_node (const overwrite_node &src)
| Copy constructor; doesn't take anything from src; default won't work. More...
| ~overwrite_node ()
bool | register_successor (successor_type &s) __TBB_override
| Add a new successor to this node. More...
bool | remove_successor (successor_type &s) __TBB_override
| Removes a successor from this node. More...
bool | try_get (input_type &v) __TBB_override
| Request an item from the sender. More...
bool | try_reserve (T &v) __TBB_override
| Reserves an item. More...
bool | try_release () __TBB_override
| Releases the reserved item. More...
bool | try_consume () __TBB_override
| Consumes the reserved item. More...
bool | is_valid ()
void | clear ()
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()
Public Member Functions inherited from tbb::flow::interface11::receiver< T >
bool | try_put (const typename internal::async_helpers< T >::filtered_type &t)
| Put an item to the receiver. More...
bool | try_put (const typename internal::async_helpers< T >::async_type &t)
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
virtual bool | register_predecessor (predecessor_type &)
| Add a predecessor to the node. More...
virtual bool | remove_predecessor (predecessor_type &)
| Remove a predecessor from the node. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()

## Protected Member Functions

task * | try_put_task (const input_type &v) __TBB_override
| Put item to successor; return task to run the successor if possible. More...
task * | try_put_task_impl (const input_type &v)
graph & | graph_reference () const __TBB_override
void | reset_receiver (reset_flags) __TBB_override
| put receiver back in initial state More...
void | reset_node (reset_flags f) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::receiver< T >
virtual task * | try_put_task_wrapper (const void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
template<typename X >
task * | try_put_task (const X &t)
virtual bool | is_continue_receiver ()
Protected Member Functions inherited from tbb::flow::interface11::sender< T >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Protected Attributes

spin_mutex | my_mutex
internal::broadcast_cache< input_type, null_rw_mutex > | my_successors
input_type | my_buffer
bool | my_buffer_is_valid
Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev

## Friends

template<typename R , typename B >
class | run_and_put_task
template<typename X , typename Y >
class | internal::broadcast_cache
template<typename X , typename Y >
class | internal::round_robin_cache

## Additional Inherited Members

Public Attributes inherited from tbb::flow::interface11::receiver< T >
__TBB_DEPRECATED typedef T | input_type
| The input type of this receiver. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type
Public Attributes inherited from tbb::flow::interface11::sender< T >
__TBB_DEPRECATED typedef T | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type

## Detailed Description

### template<typename T>
class tbb::flow::interface11::overwrite_node< T >

Definition at line 4410 of file flow_graph.h.

## Member Typedef Documentation

## input_type

template<typename T >

typedef T tbb::flow::interface11::overwrite_node< T >::input_type

Definition at line 4412 of file flow_graph.h.

## output_type

template<typename T >

typedef T tbb::flow::interface11::overwrite_node< T >::output_type

Definition at line 4413 of file flow_graph.h.

## predecessor_type

template<typename T >

typedef receiver<input_type>::predecessor_type tbb::flow::interface11::overwrite_node< T >::predecessor_type

Definition at line 4414 of file flow_graph.h.

## successor_type

template<typename T >

typedef sender<output_type>::successor_type tbb::flow::interface11::overwrite_node< T >::successor_type

Definition at line 4415 of file flow_graph.h.

## Constructor & Destructor Documentation

## overwrite_node() [1/2]

template<typename T >

__TBB_NOINLINE_SYM tbb::flow::interface11::overwrite_node< T >::overwrite_node | ( | graph & | g | ) |

inline explicit

Definition at line 4423 of file flow_graph.h.

: graph_node(g), my_buffer_is_valid(false) {
my_successors.set_owner( this );
tbb::internal::fgt_node( CODEPTR(), tbb::internal::FLOW_OVERWRITE_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), static_cast<sender<output_type> *>(this) );
}
CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::internal::fgt_node
static void fgt_node(void *, string_index, void *, void *)
Definition: _flow_graph_trace_impl.h:326
tbb::flow::interface11::overwrite_node::my_successors
internal::broadcast_cache< input_type, null_rw_mutex > my_successors
Definition: flow_graph.h:4605
tbb::flow::interface11::overwrite_node::my_buffer_is_valid
bool my_buffer_is_valid
Definition: flow_graph.h:4610
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464
tbb::flow::interface11::graph_node::graph_node
graph_node(graph &g)
Definition: flow_graph.h:888

References CODEPTR, and tbb::internal::fgt_node().

Here is the call graph for this function:

## overwrite_node() [2/2]

template<typename T >

__TBB_NOINLINE_SYM tbb::flow::interface11::overwrite_node< T >::overwrite_node | ( | const overwrite_node< T > & | src | ) |

inline

Copy constructor; doesn't take anything from src; default won't work.

Definition at line 4437 of file flow_graph.h.

:
graph_node(src.my_graph), receiver<T>(), sender<T>(), my_buffer_is_valid(false)
{
my_successors.set_owner( this );
tbb::internal::fgt_node( CODEPTR(), tbb::internal::FLOW_OVERWRITE_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), static_cast<sender<output_type> *>(this) );
}

References CODEPTR, and tbb::internal::fgt_node().

Here is the call graph for this function:

## ~overwrite_node()

template<typename T >

tbb::flow::interface11::overwrite_node< T >::~overwrite_node | ( |  | ) |

inline

Definition at line 4445 of file flow_graph.h.

{}

## Member Function Documentation

## clear()

template<typename T >

void tbb::flow::interface11::overwrite_node< T >::clear | ( |  | ) |

inline

Definition at line 4560 of file flow_graph.h.

{
spin_mutex::scoped_lock l( my_mutex );
my_buffer_is_valid = false;
}
tbb::flow::interface11::overwrite_node::my_mutex
spin_mutex my_mutex
Definition: flow_graph.h:4604
tbb::spin_mutex::scoped_lock
friend class scoped_lock
Definition: spin_mutex.h:179

## graph_reference()

template<typename T >

graph& tbb::flow::interface11::overwrite_node< T >::graph_reference | ( |  | ) | const

inline protected virtual

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 4583 of file flow_graph.h.

{
return my_graph;
}

## is_valid()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::is_valid | ( |  | ) |

inline

Definition at line 4555 of file flow_graph.h.

{
spin_mutex::scoped_lock l( my_mutex );
return my_buffer_is_valid;
}

## register_successor()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::register_successor | ( | successor_type & | r | ) |

inline virtual

Add a new successor to this node.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 4453 of file flow_graph.h.

{
spin_mutex::scoped_lock l( my_mutex );
if (my_buffer_is_valid && internal::is_graph_active( my_graph )) {
// We have a valid value that must be forwarded immediately.
bool ret = s.try_put( my_buffer );
if ( ret ) {
// We add the successor that accepted our put
my_successors.register_successor( s );
} else {
// In case of reservation a race between the moment of reservation and register_successor can appear,
// because failed reserve does not mean that register_successor is not ready to put a message immediately.
// We have some sort of infinite loop: reserving node tries to set pull state for the edge,
// but overwrite_node tries to return push state back. That is why we have to break this loop with task creation.
task *rtask = new ( task::allocate_additional_child_of( *( my_graph.root_task() ) ) )
register_predecessor_task( *this, s );
internal::spawn_in_graph_arena( my_graph, *rtask );
}
} else {
// No valid value yet, just add as successor
my_successors.register_successor( s );
}
return true;
}
s
void const char const char int ITT_FORMAT __itt_group_sync s
Definition: ittnotify_static.h:91
task
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task * task
Definition: ittnotify_static.h:119
tbb::flow::interface11::internal::spawn_in_graph_arena
void spawn_in_graph_arena(tbb::flow::interface10::graph &g, tbb::task &arena_task)
Spawns a task inside graph arena.
Definition: _flow_graph_impl.h:521
tbb::flow::interface11::internal::is_graph_active
bool is_graph_active(tbb::flow::interface10::graph &g)
Definition: _flow_graph_impl.h:494
tbb::flow::interface11::overwrite_node::my_buffer
input_type my_buffer
Definition: flow_graph.h:4609
tbb::flow::interface10::graph::root_task
__TBB_DEPRECATED tbb::task * root_task()
Returns the root task of the graph.
Definition: _flow_graph_impl.h:374

References tbb::flow::interface11::internal::is_graph_active(), s, and tbb::flow::interface11::internal::spawn_in_graph_arena().

Here is the call graph for this function:

## remove_successor()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::remove_successor | ( | successor_type & | r | ) |

inline virtual

Removes a successor from this node.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 4477 of file flow_graph.h.

{
spin_mutex::scoped_lock l( my_mutex );
my_successors.remove_successor(s);
return true;
}

References s.

## reset_node()

template<typename T >

void tbb::flow::interface11::overwrite_node< T >::reset_node | ( | reset_flags | f | ) |

inline protected virtual

Implements tbb::flow::interface11::graph_node.

Definition at line 4613 of file flow_graph.h.

{
my_buffer_is_valid = false;
if (f&rf_clear_edges) {
my_successors.clear();
}
}
tbb::flow::interface11::rf_clear_edges
@ rf_clear_edges
Definition: _flow_graph_impl.h:161

References tbb::flow::interface11::rf_clear_edges.

## reset_receiver()

template<typename T >

void tbb::flow::interface11::overwrite_node< T >::reset_receiver | ( | reset_flags | f | ) |

inline protected virtual

put receiver back in initial state

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 4611 of file flow_graph.h.

{}

## try_consume()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::try_consume | ( |  | ) |

inline virtual

Consumes the reserved item.

Reimplemented from tbb::flow::interface11::internal::untyped_sender.

Definition at line 4553 of file flow_graph.h.

{ return true; }

## try_get()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::try_get | ( | input_type & |  | ) |

inline virtual

Request an item from the sender.

Reimplemented from tbb::flow::interface11::sender< T >.

Definition at line 4535 of file flow_graph.h.

{
spin_mutex::scoped_lock l( my_mutex );
if ( my_buffer_is_valid ) {
v = my_buffer;
return true;
}
return false;
}

## try_put_task()

template<typename T >

task* tbb::flow::interface11::overwrite_node< T >::try_put_task | ( | const input_type & | t | ) |

inline protected virtual

Put item to successor; return task to run the successor if possible.

Implements tbb::flow::interface11::receiver< T >.

Reimplemented in tbb::flow::interface11::write_once_node< T >.

Definition at line 4570 of file flow_graph.h.

{
spin_mutex::scoped_lock l( my_mutex );
return try_put_task_impl(v);
}
tbb::flow::interface11::overwrite_node::try_put_task_impl
task * try_put_task_impl(const input_type &v)
Definition: flow_graph.h:4575

References internal::successor_cache< T, spin_rw_mutex >::my_mutex.

## try_put_task_impl()

template<typename T >

task* tbb::flow::interface11::overwrite_node< T >::try_put_task_impl | ( | const input_type & | v | ) |

inline protected

Definition at line 4575 of file flow_graph.h.

{
my_buffer = v;
my_buffer_is_valid = true;
task * rtask = my_successors.try_put_task(v);
if (!rtask) rtask = SUCCESSFULLY_ENQUEUED;
return rtask;
}
tbb::flow::internal::SUCCESSFULLY_ENQUEUED
static tbb::task *const SUCCESSFULLY_ENQUEUED
Definition: _flow_graph_impl.h:61

References internal::successor_cache< T, spin_rw_mutex >::my_successors, and tbb::flow::internal::SUCCESSFULLY_ENQUEUED.

## try_release()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::try_release | ( |  | ) |

inline virtual

Releases the reserved item.

Reimplemented from tbb::flow::interface11::internal::untyped_sender.

Definition at line 4550 of file flow_graph.h.

{ return true; }

## try_reserve()

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::try_reserve | ( | T & | v | ) |

inline virtual

Reserves an item.

Reimplemented from tbb::flow::interface11::sender< T >.

Definition at line 4545 of file flow_graph.h.

{
return try_get(v);
}
tbb::flow::interface11::overwrite_node::try_get
bool try_get(input_type &v) __TBB_override
Request an item from the sender.
Definition: flow_graph.h:4535

## Friends And Related Function Documentation

## internal::broadcast_cache

template<typename T >
template<typename X , typename Y >

friend class internal::broadcast_cache

friend

Definition at line 4568 of file flow_graph.h.

## internal::round_robin_cache

template<typename T >
template<typename X , typename Y >

friend class internal::round_robin_cache

friend

Definition at line 4569 of file flow_graph.h.

## run_and_put_task

template<typename T >
template<typename R , typename B >

friend class run_and_put_task

friend

Definition at line 4567 of file flow_graph.h.

## Member Data Documentation

## my_buffer

template<typename T >

input_type tbb::flow::interface11::overwrite_node< T >::my_buffer

protected

Definition at line 4609 of file flow_graph.h.

## my_buffer_is_valid

template<typename T >

bool tbb::flow::interface11::overwrite_node< T >::my_buffer_is_valid

protected

Definition at line 4610 of file flow_graph.h.

## my_mutex

template<typename T >

spin_mutex tbb::flow::interface11::overwrite_node< T >::my_mutex

protected

Definition at line 4604 of file flow_graph.h.

## my_successors

template<typename T >

internal::broadcast_cache< input_type, null_rw_mutex > tbb::flow::interface11::overwrite_node< T >::my_successors

protected

Definition at line 4605 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.